# idea-personal-event-srv

idea around a personal event server

## overview

Ideally it would be a network of agents, that can broadcast and see messages, only responding to interested events.
A brokerless setup.
Further, having one or more endpoints for recieving, and even calling webhooks.
The webhooks must be a specified node.
Perhaps the webhooks recieved would broadcast a message on the node network, and specific types of node network messages would translate out to calling a webhook.

## Use-cases

* agent on a node doing a liveness check on a service
* agent on a node sending metric like battery power status change
* container build event
* curl for modtime change, and sync a repo

## Alternate approach

Since there is data pushed and data pulled, as well as new services brought in and services expected, consul.io is a very possible project to use.
Publishing services is interesting, but maybe not the connect proxy for routing.
Primarily for kv usage, and possibly for liveness testing of services in the datacenter.

# references

* https://github.com/adnanh/webhook
* https://github.com/zeromq/zyre
  * https://github.com/zeromq/czmq
  * https://github.com/zeromq/gomq
* https://github.com/ethereum/wiki/wiki/Whisper
  * https://archive.fosdem.org/2018/schedule/event/whisper/
* https://www.consul.io/
* https://github.com/cloudevents/spec

